Package com.sas.services.information.browse

# Interface BrowseMetadataInterface

All Known Implementing Classes:
  `BrowseMetadata`

public interface BrowseMetadataInterface

Since:
  1.1.3

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `CREATE_KEY`
  The map key to get the object's creation date.
  `static final String`
  `DESC_KEY`
  The map key to get the object's description.
  `static final String`
  `ISAFOLDER_KEY`
  The map key to get the indicator if the object is a folder;
  `static final String`
  `ISENTITYKEY_KEY`
  The map key to get the object's Information Service entity key.
  `static final String`
  `KEYWORDS_KEY`
  The map key to get the object's keywords.
  `static final String`
  `MEMBERS_KEY`
  The map key to get an object's members, if it's a folder.
  `static final String`
  `MODIFY_KEY`
  The map key to get the object's latest modified date.
  `static final String`
  `NAME_KEY`
  The map key to get the object's name.
  `static final String`
  `NATIVETYPE_KEY`
  The map key to get the repository native type (e.g., "Transformation" rather than "Report".
  `static final String`
  `PARENTTREE_KEY`
  The map key to get the Parent Tree assocation;
  `static final String`
  `REPOSID_KEY`
  The map key to get the object's repository id.
  `static final String`
  `SMARTCLASS_KEY`
  The map key to get the object's smart object Java class.
  `static final String`
  `SMARTTYPE_KEY`
  The map key to get the object's smart object type (e.g., "Report" rather than "Transformation".
  `static final String`
  `SOFTWARETREES_KEY`
  The map key to get SoftwareTrees from a SoftwareComponent.
  `static final String`
  `SUBFOLDERS_KEY`
  the map key to get the object's subfolders, if it's a folder.
  `static final String`
  `TREES_KEY`
  The map key to get the Trees association.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Object`
  `get(String key)`
  Get an arbitrary object from the map.
  `long`
  `getCreateDate()`
  Get the date the metadata object was created.
  `Date`
  `getCreateDateAsDate()`
  Get the date the metadata object was created.
  `String`
  `getDescription()`
  Get the object description.
  `String`
  `getISEntityKey()`
  Get the Information Service entity key for this object.
  `List`
  `getKeywords()`
  Get a List of Strings with the keywords that are associated with this object.
  `List`
  `getMembers()`
  Get the members if this is a folder.
  `long`
  `getModifyDate()`
  Get the date the metadata object was most recently changed.
  `Date`
  `getModifyDateAsDate()`
  Get the date the metadata object was most recently changed.
  `String`
  `getName()`
  Get the object name.
  `String`
  `getNativeType()`
  Get the repository native type for this object.
  `List`
  `getParents()`
  Get the list of parent objects.
  `Map`
  `getRawData()`
  Get the Map with the raw data for this object.
  `String`
  `getReposId()`
  Get the object's repository ID.
  `String`
  `getSmartType()`
  Get the "smart" type of this object.
  `List`
  `getSubfolders()`
  Get the subfolders if this is a folder.
  `boolean`
  `isAFolder()`
  Returns true if this object represents a folder in the metadata.
  `String`
  `toString()`
  Return a simple string representation of the object.

- ## Field Details

  - ### NAME_KEY

    static final String NAME_KEY
    The map key to get the object's name.
    See Also:
      - Constant Field Values

  - ### DESC_KEY

    static final String DESC_KEY
    The map key to get the object's description.
    See Also:
      - Constant Field Values

  - ### CREATE_KEY

    static final String CREATE_KEY
    The map key to get the object's creation date. This should be a string-coded long.
    See Also:
      - Constant Field Values

  - ### MODIFY_KEY

    static final String MODIFY_KEY
    The map key to get the object's latest modified date. This should be a string-coded long.
    See Also:
      - Constant Field Values

  - ### KEYWORDS_KEY

    static final String KEYWORDS_KEY
    The map key to get the object's keywords.
    See Also:
      - Constant Field Values

  - ### SMARTTYPE_KEY

    static final String SMARTTYPE_KEY
    The map key to get the object's smart object type (e.g., "Report" rather than "Transformation".
    See Also:
      - Constant Field Values

  - ### SMARTCLASS_KEY

    static final String SMARTCLASS_KEY
    The map key to get the object's smart object Java class.
    See Also:
      - Constant Field Values

  - ### NATIVETYPE_KEY

    static final String NATIVETYPE_KEY
    The map key to get the repository native type (e.g., "Transformation" rather than "Report".
    See Also:
      - Constant Field Values

  - ### ISENTITYKEY_KEY

    static final String ISENTITYKEY_KEY
    The map key to get the object's Information Service entity key. This key can be used to fetch the "real" smart object.
    See Also:
      - Constant Field Values

  - ### MEMBERS_KEY

    static final String MEMBERS_KEY
    The map key to get an object's members, if it's a folder.
    See Also:
      - Constant Field Values

  - ### SUBFOLDERS_KEY

    static final String SUBFOLDERS_KEY
    the map key to get the object's subfolders, if it's a folder.
    See Also:
      - Constant Field Values

  - ### SOFTWARETREES_KEY

    static final String SOFTWARETREES_KEY
    The map key to get SoftwareTrees from a SoftwareComponent. This is used to get subtrees from the root of the hierarchy.
    See Also:
      - Constant Field Values

  - ### REPOSID_KEY

    static final String REPOSID_KEY
    The map key to get the object's repository id.
    See Also:
      - Constant Field Values

  - ### ISAFOLDER_KEY

    static final String ISAFOLDER_KEY
    The map key to get the indicator if the object is a folder;
    See Also:
      - Constant Field Values

  - ### TREES_KEY

    static final String TREES_KEY
    The map key to get the Trees association.
    See Also:
      - Constant Field Values

  - ### PARENTTREE_KEY

    static final String PARENTTREE_KEY
    The map key to get the Parent Tree assocation;
    See Also:
      - Constant Field Values

- ## Method Details

  - ### getRawData

    Map getRawData()
    Get the Map with the raw data for this object. This Map can be wrapped with a "smarter" object for accessing the data.
    Returns:
      A map that represents simple attributes with String values, and associated objects as a List of Map objects.

  - ### get

    Object get(String key)
    Get an arbitrary object from the map. This may be an attribute or an association. Attributes have String values, associations are represented by a List of BrowseMetadataInterface objects.
    Parameters:
      `key` - The name of the attribute or association.
    Returns:
      A String representing an attribute value, or a List if key is an association.

  - ### getName

    String getName()
    Get the object name.
    Returns:
      The object name string.

  - ### getDescription

    String getDescription()
    Get the object description.
    Returns:
      The object description string. An empty string will be returned rather than null if no description exists.

  - ### getCreateDate

    long getCreateDate()
    Get the date the metadata object was created.
    Returns:
      A long representing the date and time the object was created.

  - ### getModifyDate

    long getModifyDate()
    Get the date the metadata object was most recently changed.
    Returns:
      A long with the latest modification date and time for the object.

  - ### getCreateDateAsDate

    Date getCreateDateAsDate()
    Get the date the metadata object was created.
    Returns:
      A long representing the date and time the object was created.

  - ### getModifyDateAsDate

    Date getModifyDateAsDate()
    Get the date the metadata object was most recently changed.
    Returns:
      A long with the latest modification date and time for the object.

  - ### getKeywords

    List getKeywords()
    Get a List of Strings with the keywords that are associated with this object.
    Returns:
      A List of String objects with the keywords.

  - ### getSmartType

    String getSmartType()
    Get the "smart" type of this object. For instance, return "Report" rather than "Transformation". If the smart object type couldn't be determined, the string "Metadata" will be returned.
    Returns:
      The smart object type of this object.

  - ### getNativeType

    String getNativeType()
    Get the repository native type for this object. For instance, "Transformation" rather than "Report".
    Returns:
      The repository specific type for this object.

  - ### getISEntityKey

    String getISEntityKey()
    Get the Information Service entity key for this object. This key makes it easy to retrieve the "real" metadata object for this browse object so it can be updated.
    Returns:
      The Information Service entity key.

  - ### isAFolder

    boolean isAFolder()
    Returns true if this object represents a folder in the metadata. For data in the SAS Metadata Server, being a folder doesn't necessarily imply that it's part of the BIP Tree hierarchy.
    Returns:
      True if the object is a folder, false otherwise.

  - ### getMembers

    List getMembers()
    Get the members if this is a folder.
    Returns:
      a List of BrowseMetadataInterface objects representing the members of the folder, or null if it's not a folder.

  - ### getSubfolders

    List getSubfolders()
    Get the subfolders if this is a folder.
    Returns:
      a List of BrowsemetadataInterface objects representing the subfolders of this folder, or null if it's not a folder.

  - ### getParents

    List getParents()
    Get the list of parent objects. This will either be the element(s) of the ParentTree association, if that's found, or the Trees asociation if that's found.
    Returns:
      A List of likely parent BrowseMetadataInterface objects. If none are found, an empty List is returned.

  - ### getReposId

    String getReposId()
    Get the object's repository ID. The id by itself may or may not be sufficient to actually retrieve the object from the repository, but it should at least be a unique identifier for the object within the repository. * @return The String representation of the repository identifier.

  - ### toString

    String toString()
    Return a simple string representation of the object.
    Overrides:
      `toString` in class `Object`
    Returns:
      A String object representing the metadata object.